require "recite/version"

module Recite
  def self.copy(klass, &block)
    Class.new(klass) do

      def initialize(methods={})
        methods.each do |name, value|
          define_singleton_method(name) {|*args| value }
        end
      end

      alias instance_of? is_a?
      class_eval(&block)
    end
  end

  def self.instance(klass, methods={}, &block)
    copy(klass, &block).new(methods)
  end
end
